* Unterteilt die Altersvariable in titanic.dta in
* fiktive Gruppen

version 9
set seed 4731
use titanic, clear
sort age sex class

* Kinder: Gleichverteilung zwischen 0 und 20
gen age2 = uniform()*15 if age == 0 & survived==0
replace age2 = uniform()*15 if age == 0 & survived==1

* Erwachsene: chi^2, mit hherem s bei bei Nichtberlebenden
replace age2 = invnormal(uniform()) * 8 + 35 if age == 1 & survived == 0
replace age2 = invnormal(uniform()) * 6 + 30 if age == 1 & survived == 1
replace age2 = uniform()*70 + 15 if age2 < 15 & age == 0 & survived == 0 /* Korrektur */
replace age2 = uniform()*60 + 15 if age2 < 15 & age == 0 & survived == 1 /* Korrektur */

* Runden auf ganze Zahlen
replace age2 = round(age2,1)

lab var age2 "Alter in Jahren (fiktiv)"
notes age2: Variable kuenstlich gebilded
notes age2: siehe crtitanic2.do

keep sex class age2 survived
order sex class age2 survived
compress

save titanic2, replace
exit

